/*
	rcs_observermain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		RCS_OBSERVER_MODULE

	MODIFICATIONS:
	Sun Dec 17 15:28:06 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rcs_observer.hh"	// definition of RCS_OBSERVER_MODULE

// flag signifying main loop is to terminate
int rcs_observer_done = 0;

//signal handler for ^C
extern "C" void rcs_observer_quit(int sig);
void rcs_observer_quit(int sig)
{
	rcs_observer_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int rcs_observer_run();

int rcs_observer_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	RCS_OBSERVER_MODULE *rcs_observer = new RCS_OBSERVER_MODULE();

	// set the SIGINT handler
	signal(SIGINT, rcs_observer_quit);

	// enter main loop
	while(!rcs_observer_done)
	{
		rcs_observer->controller();

		timer->wait();
	}

	// Delete Modules
	delete rcs_observer;

	// Delete Timer
	delete timer;
}

