/*
	rcs_observersvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Sun Dec 17 15:28:06 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "rcs_observern.hh" 	// rcs_observerFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *rcs_observer_cmd = NULL;
static RCS_STAT_CHANNEL *rcs_observer_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// rcs_observer
	rcs_observer_cmd = new RCS_CMD_CHANNEL(rcs_observerFormat, "rcs_observer_cmd", "rcs_observersvr", "rcs_observer.nml");
	if(NULL == rcs_observer_cmd)
		return -1;
	if(!rcs_observer_cmd->valid())
		return -1;

	rcs_observer_stat = new RCS_STAT_CHANNEL(rcs_observerFormat, "rcs_observer_sts", "rcs_observersvr", "rcs_observer.nml");
	if(NULL == rcs_observer_stat)
		return -1;
	if(!rcs_observer_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "rcs_observersvr", "rcs_observer.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// rcs_observer
	if(NULL != rcs_observer_cmd)
	{
		delete rcs_observer_cmd;
		rcs_observer_cmd = NULL;
	}

	if(NULL != rcs_observer_stat)
	{
		delete rcs_observer_stat;
		rcs_observer_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int rcs_observersvr_run();

int rcs_observersvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

